using System;

namespace takmicenje02
{
    class Program
    {
        static void Main(string[] args)
        {
            int n = int.Parse(Console.ReadLine());
            string[] zaliha = Console.ReadLine().Split(' ');
            int o = int.Parse(zaliha[0]);
            int a = int.Parse(zaliha[1]);
            int b = int.Parse(zaliha[2]);
            int ab = int.Parse(zaliha[3]);
            
            for(int i = 0; i <= n; i++) { 
                string[] krv = Console.ReadLine().Split(' ');
                int krvpotrebna = int.Parse(krv[1]);
                string krvgrupa = (krv[0]);
                int krvdata = 0;
                int zp = 0;
                if (krvgrupa == "O" || krvgrupa == "o") zp = o;
                else if (krvgrupa == "A" || krvgrupa == "a") zp = a;
                else if (krvgrupa == "B" || krvgrupa == "b") zp = b;
                else if (krvgrupa == "AB" || krvgrupa == "ab") zp = ab;

                if (zp >= krvpotrebna) { krvdata = krvpotrebna; zp -= krvdata; }
                else if (zp > 0) { krvdata = zp; krvpotrebna -= krvdata; zp -= krvdata; }
                if (krvdata == krvpotrebna)
                {
                    if (krvgrupa == "O" || krvgrupa == "o")
                    {
                        Console.WriteLine("moguce");
                        Console.WriteLine(krvdata + " 0 0 0");
                    }
                }
                







            }
} } }